//------------------------------------------------------------------------------
//   Header-Datei:          Hash.h
//   zuletzt gendert am:   13.6.99/Kp
//------------------------------------------------------------------------------

#include <string.h>
#include <iostream.h>

const unsigned DATALEN = 20;

class Item
{
    public:
      Item 	  (int Key=0, char *Data="")   { key = Key; strcpy (data, Data); }
      virtual ~Item	() { }
      void 	  getKey  (int  &Key)	{ Key = key; }
      void    setKey  (int   Key)	{ key = Key; }
      void 	  getdata (char *Data)  { strcpy (Data, data); }
      void    setdata (char *Data)  { strcpy (data, Data); }

      int     key; 			        // Schlssel
      char    data[DATALEN+1];      // Datenfeld des Item
};

class HTable
{
    public:
      HTable           			      ();
      virtual ~HTable  			   	  () { }
      virtual int    Hash 			  (int  key);
      virtual void   InsertItem		  (Item item);
      virtual void   DeleteItem		  (int  key);
      virtual void   HSearch		  (int  key,  int &index, int &found);
      virtual void   ReHash 		  (int  flag);
      virtual void	PrintHtable		  ();
      virtual unsigned int numericKey (char *stringKey);

      int 	tsize;           		  // Start-Gre der Hash-Tabelle
      int 	step; 					  // Start-Gre fr den Ausweich-Schritt
      int	hsize;               	  // aktuelle Tabellengre
      int 	ItemNum;				  // Anzahl belegter Items
      Item	*table;					  // Item-Feld
};



