//==============================================================================
//  Testrahmen zur Klasse Btree: Version mit Einfgen und Lschen
//  zuletzt gendert:   07.01.01 / Kp
//==============================================================================

#include "Btree.h"

//---------------------------------------------------------------------------
void weiter(void)
{
	cout << "\n                       <ENTER>";// Prompt ausgeben
    getch();
	clrscr();                                  // Screen lschen
}

void main()
{
    char databaseName[NAMLEN];               // Dateiname der Datenbank
    int  wert=1;
    char keyString[15];
    int nextOperation;

    //	Baum durch Einfgen von Knoten aufbauen
    cout << "\nB-Baum-Operationen";
    cout << "\n------------------\n";
    cout << "\nDateiname der Datenbank : ";
    cin.getline (databaseName, NAMLEN);

    // Datenbank neu anlegen bzw. vorhandene Datenbank ffnen
    Btree B(databaseName);

    // B-Baum-Operationen durchfhren
    // ------------------------------
	do
	{ clrscr(); 
      B.printDatabase();
      cout << "\nNaechste Operation (E=Einfuegen|L=Loeschen|X=Exit): ";
      nextOperation=toupper(getch());

      // Schlssel einfgen
      if (nextOperation=='E')
      { cout << "\nNaechster einzufuegender Schluessel:  ";   
		cin >> keyString;
        wert = atoi(keyString);
		if ((wert>0) && (wert<100))
		{ strcpy(keyString,"=======\0");
		  B.insertKey(wert, keyString);		   
		}
        else if (wert!=-1)
          cout << "   ------   Schluessel liegt nicht im Bereich [1 .. 99] !\n" ;
      }
      // Schlssel lschen
      else if (nextOperation=='L')
      { cout << "\nNaechster zu loeschender Schluessel:  ";  
        wert = 0;
		cin >> keyString;
        wert = atoi(keyString);
		if (wert!=-1) B.deleteKey(wert);	   
      }
      else;
    } while (nextOperation!='X');

    // Datenbank aufsteigend sortiert ausgeben mit inOrder-Durchlauf
    // -------------------------------------------------------------
    B.inOrderDatabase();
    weiter();
    return;
}
